/*
@copyright(disclaimer)

Licensed Materials - Property of IBM
IBM  Enterprise Information Portal  for Multiplatforms V8.1  (program number 5724-B43)
(c) Copyright IBM Corp. 1998,  2002. All Rights Reserved.

US Government Users Restricted Rights
Use, duplication or disclosure restricted by GSA ADP Schedule
Contract with IBM Corp.

DISCLAIMER OF WARRANTIES :

Permission is granted to copy and modify this  Sample code, and to
distribute modified versions provided that both the copyright
notice,- and this permission notice and warranty disclaimer  appear in all copies and modified
versions.

THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.
IBM  AND ITS SUPPLIERS AND LICENSORS  DISCLAIM
ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY
OF NON-INFRINGEMENT AND THE IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
PARTICULAR PURPOSE. IN NO EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY
DAMAGES ARISING OUT OF THE USE OF  OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF
THE SAMPLE CODE, OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL
IBM OR ITS LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA,
OR FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS LICENSORS OR SUPPLIERS
HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.

@endCopyright
*/

import com.ibm.mm.beans.*;
import java.beans.*;

/**
 * This sample demonstrates the use of the CMBConnection bean to connect to
 * EIP's federated server.
 */
public class DemoConnect {
    UtilPersistent per = new UtilPersistent();
    UtilSimpleUI ui = new UtilSimpleUI();
    CMBConnection connBean = null;

    DemoConnect() {
        try {
            System.out.println("Creating CMBConnection bean using " + "ser/class/jar specified in the classpath.");
            connBean = (com.ibm.mm.beans.CMBConnection) Beans.instantiate(null, "com.ibm.mm.beans.CMBConnection");
        } catch (Exception exc) {
            exc.printStackTrace();
        }
    }

    void changeProperty() {
        try {
            String srv = ui.getString("Enter the server name: ");
            connBean.setServerName(srv);

            String uid = ui.getString("Enter the user ID: ");
            connBean.setUserid(uid);

            String pwd = ui.getString("Enter the password: ");
            connBean.setPassword(pwd);
        } catch (Exception exc) {
            exc.printStackTrace();
        }
    }

    void checkProperty() {
        try {
            if (connBean.getServerName().length() == 0) {
                String srv = ui.getString("Server name is empty, " + "please enter the server name:");
                connBean.setServerName(srv);
            }
            if (connBean.getUserid().length() == 0) {
                String uid = ui.getString("User ID is empty, please enter the user ID:");
                connBean.setUserid(uid);
            }
            if (connBean.getPassword().length() == 0) {
                String pwd = ui.getString("Password is empty, please enter the password:");
                connBean.setPassword(pwd);
            }
        } catch (Exception exc) {
            exc.printStackTrace();
        }
    }

    void connect() {
        checkProperty();

        try {
            System.out.println("Connecting...");
            connBean.connect();
            System.out.println("OK, connected\n");
        } catch (Exception exc) {
            exc.printStackTrace();
        }
    }

    void disconnect() {
        try {
            System.out.println("Disconnecting...");
            if (connBean.isConnected()) {
                connBean.disconnect();
            }
            System.out.println("OK, disconnected");
        } catch (Exception exc) {
            exc.printStackTrace();
        }
    }

    void connectUsingEvent() {
        checkProperty();

        try {
            System.out.println("Connecting...");
            connBean.onCMBConnectionRequest(new CMBConnectionRequestEvent(connBean, CMBConnectionRequestEvent.CMB_REQUEST_CONNECT));
            System.out.println("OK, connected\n");
        } catch (Exception exc) {
            exc.printStackTrace();
        }
    }

    void disconnectUsingEvent() {
        try {
            System.out.println("Disconnecting...");
            connBean.onCMBConnectionRequest(
                new CMBConnectionRequestEvent(connBean, CMBConnectionRequestEvent.CMB_REQUEST_DISCONNECT));
            System.out.println("OK, disconnected");
        } catch (Exception exc) {
            exc.printStackTrace();
        }
    }

    void load() {
        connBean = (CMBConnection) per.load();
    }

    void save() {
        per.save(connBean);
    }

    public static void main(String argv[]) {
        String demoName = "IBM CMB Demonstration program: DemoConnect";
        String copyright = "C) Copyright IBM Corp. 1994,1999. All Rights Reserved.";

        System.out.println("");
        System.out.println(demoName);
        System.out.println(copyright);
        System.out.println("");
        System.out.println("");

        UtilSimpleUI ui = new UtilSimpleUI();
        DemoConnect demo = new DemoConnect();
        boolean loopControl = true;

        while (loopControl) {
            System.out.println("");
            System.out.println("Selections:");
            System.out.println("0. Exit");
            System.out.println("1. Re-load the CMBConnection bean from a file");
            System.out.println("2. Change property values");
            System.out.println("3. Connect");
            System.out.println("4. Disconnect");
            System.out.println("5. Save this CMBConnection bean to a file");
            switch (ui.getInteger("Enter your selection:")) {
                case 0 :
                    loopControl = false;
                    break;
                case 1 :
                    demo.load();
                    break;
                case 2 :
                    demo.changeProperty();
                    break;
                case 3 :
                    demo.connect();
                    break;
                case 4 :
                    demo.disconnect();
                    break;
                case 5 :
                    demo.save();
                    break;
            }
        }

        if (demo.connBean.isConnected())
            demo.disconnect();

        System.out.println("Bye.");
    }
}