/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Enterprise Information Portal for Multiplatforms V8.1 (program number 5724-B43)*
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                         *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************/

/*
 * Filename       : TExecuteGetMatchesTS.java
 * Description    : Connect to Text Search server.
 *                  Create query string specifying that highlighting 
 *                  information is wanted.
 *                  Get results in a resultset cursor.
 *                  Loop through results.
 *                  Display items found.
 *                  Disconnect from Text Search Datastore.
 */

import com.ibm.mm.sdk.common.*;
import com.ibm.mm.sdk.server.*;
import java.io.*;
import java.lang.*;

// TExecuteGetMatchesTS class
public class TExecuteGetMatchesTS implements DKConstant
{
  // Main method
  public static void main(String argv[])
  {
    DKDatastoreTS dsTS = null;
    try {
      //-------------------------------------------------------------- 
      // Checking for input parameters
      //-------------------------------------------------------------- 
      if (argv.length < 2){
          System.out.println("Invoke Syntax: " );
          System.out.println("  java TExecuteGetMatchesTS <srchSrv> <srchIndex> <libSrvName>" );
          return;
      }
      
      String srchSrv    = argv[0];
      String strIndex   = argv[1];
      String strLibName = argv[2];
       
      dsTS = new DKDatastoreTS();
      dkResultSetCursor pCur = null;
      DKNVPair parms[] = null;
      Integer iValObj = null;
      System.out.println("connecting to datastore"); 
      dsTS.connect(srchSrv,"","","LIBACCESS=(" + strLibName + ",FRNADMIN,PASSWORD)");
      System.out.println("datastore connected srchSrv: " + srchSrv + " libSrvName: " + strLibName); 
      String cmd = "SEARCH=(COND=(UNIX));" +
                   "OPTION=(SEARCH_INDEX=" + strIndex + 
                   ";MAX_RESULTS=5;MATCH_INFO=YES;MATCH_DICT=NO)"; 
      Integer iVal;
      DKDDO p = null;
      DKPid pid = null;
      int i = 0;
      int numDataItems = 0;
      short j = 0;
      dkDataObjectBase pDOBase = null;
      DKMatchesInfoTS pMInfo = null;
      DKMatchesDocSectionTS pMSect = null;
      DKMatchesParagraphTS pMPara = null;
      DKMatchesTextItemTS  pMText = null;
      int li = 0;
      int lj = 0;
      int lk = 0;
      int lm = 0;
      int numSects = 0;
      int numParas = 0;
      int numTextItems = 0;
      int numNewLines = 0;
      int numMatches = 0;
      int numMatchItems = 0;
      int iData = 0;
      int iData2 = 0;
      String strDataName;
      Object a = null;
      System.out.println("query string " + cmd);
      System.out.println("executing query");
      pCur = dsTS.execute(cmd,DK_TEXT_QL_TYPE,parms);
      System.out.println("datastore executed query");
      System.out.println("process query results");
      while (pCur.isValid()){
         p = pCur.fetchNext();
         if (p != null){
            i = pCur.getPosition();
            System.out.println("=====> Item " + i + " <=====");
            pid = p.getPidObject();
            System.out.println("pid is " + pid.pidString());
            numDataItems = p.dataCount();
            for (j = 1; j <= numDataItems; j++){
                System.out.println("in loop " + j);
                a = p.getData(j);
                strDataName = p.getDataName(j);
                System.out.println("Attribute Name " + strDataName );
                if (a instanceof String)
                    System.out.println("   Attribute Value " + a);    
                else if (a instanceof Integer)
                    System.out.println("   Attribute Value " + a);    
                else if (a instanceof Short)
                    System.out.println("   Attribute Value " + a);    
                else if (a instanceof DKMatchesInfoTS){
                    System.out.println("DKMatchesInfoTS found");
                    pMInfo = (DKMatchesInfoTS)a;
 	                if (pMInfo != null)	{
                        System.out.println(" ************* Doc matches info **************** ");    
 	                    strDataName = pMInfo.getDocumentName();
 	                    numSects = pMInfo.numberOfSections();
                        System.out.println( "document name : " + strDataName + " number of sections : " + numSects );
 	                    for (li = 1; li <= numSects; li++) {
 	                         pMSect = pMInfo.getSection(li);
 	                         strDataName = pMSect.getSectionName();
 	                         numParas = pMSect.numberOfParagraphs();
                             System.out.println( "section name : " + li + " " + strDataName 
                                 + " number of paragraphs : " + numParas );
 	                         for (lj = 1; lj <= numParas; lj++) {
 	                             pMPara = pMSect.getParagraph(lj);
 	                             iData = pMPara.getCCSID();
 	                             iData2 = pMPara.getLanguageId();
 	                             numTextItems = pMPara.numberOfTextItems();
                                 System.out.println( "paragraph : ccsid " + iData + " lang " +
                                          iData2 + " " + " number of text items : " + numTextItems );
 	                             for (lk = 1; lk <= numTextItems; lk++) {
 	                                 pMText = pMPara.getTextItem(lk);
 	                                 strDataName = pMText.getText();
                                     System.out.println( "text item : " + lk + " " + strDataName );
 	                                 if (pMText.isMatch()){
 	                                    numMatchItems = pMText.numberOfMatches();
                                        System.out.println("Number of matches found " + numMatchItems);
                                        for (lm = 1; lm <= numMatchItems; lm++) {
                                             pMText.setMatchIndex(lm);
 	                                         iData = pMText.getOffset();
 	                                         iData2 = pMText.getLength();
                                             System.out.println( "text match found : offset " + iData + " len " + iData2 );         
                                             numMatches++;
                                        }
 	                                 }
 	                                 numNewLines = pMText.numberOfNewLines();
                                     System.out.println( "number of text New lines :  " + numNewLines );
 	                             }
 	                         }
 	                    }
                        System.out.println( "number of matches :  " + numMatches );
                        numMatches = 0;
 	                } // endif pMInfo       
                } // end else
            } // end for
         }
      }
      System.out.println("destroy cursor");
      pCur.destroy(); // Finished with the cursor
      System.out.println("query results processed");
      dsTS.disconnect();
      System.out.println("datastore disconnected"); 
      dsTS.destroy();
    }
    catch (DKException exc){
     try {
         dsTS.destroy();
     }
     catch (Exception e)
     {
      e.printStackTrace();
     }      
      System.out.println("Exception name " + exc.name());
      System.out.println("Exception message " + exc.getMessage());
      exc.printStackTrace();
    }
    catch (Exception exc){
     try {
         dsTS.destroy();
     }
     catch (Exception e)
     {
      e.printStackTrace();
     }      
      System.out.println("Exception message " + exc.getMessage());
      exc.printStackTrace();
    }

  }
}

