/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Enterprise Information Portal for Multiplatforms V8.1 (program number 5724-B43)*
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                         *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************/
                         
// sample to process a workflow in WorkFlow/WorkBasket

/*
 * Filename : tProcessWFS.java
 * Description : Process a workflow in WorkFlow/WorkBasket
 *
 */     

import com.ibm.mm.sdk.common.*;
import com.ibm.mm.sdk.server.*;
import java.io.*;

public class TProcessWFS
        implements DKConstant, DKMessageId
{

  // Main method
  public static void main(String argv[])
  {
    System.out.println("begin...");
    
    DKDatastoreDL dsDL = null;
    try {
        dsDL = new DKDatastoreDL();
        DKWorkFlowServiceDL wfDL = new DKWorkFlowServiceDL(dsDL);
        System.out.println("Datastore DL created");
        System.out.println("connecting to datastore");
        dsDL.connect("lsmufasa", "FRNADMIN", "PASSWORD", "");
        System.out.println("datastore connected");
	    if (wfDL.isConnected())
	        System.out.println("workflow service has been connected");
	    else
	        System.out.println("workflow service is not connected");

        String itemID   = new String("D8@AENOGY3H##QH6");
        String itemIDWF = new String("HI7MOPALUPFQ1U47");
        String itemIDWB = new String("UTXDCKJSP@H##MU8");

        System.out.println("Starting item id = " + itemID);
        wfDL.startWorkFlowItem(itemID,        //itemID
                           itemIDWF,        //itemIDWF
                           null,                   //itemIDWB
                           true,                   //overload
                           DK_WIP_DEFAULT_PRIORITY   //initial_priority
						  );
        System.out.println("Item id " + itemID + " started");

        System.out.println("Routing item id = " + itemID +
                                " to workbasket " + itemIDWB);
        wfDL.routeWipItem(itemID,         //itemID 
                      itemIDWB,         //itemIDWB, 
                      true,                       //overload 
                      DK_NO_PRIORITY_CHANGE      //priority
					 );	  
        System.out.println("Item id " + itemID + " routed");

        System.out.println("Complete item id = " + itemID + " .... ");
        wfDL.completeWorkFlowItem(itemID);
        System.out.println("Item id " + itemID + " completed");

        dsDL.disconnect();
        System.out.println("datastore disconnected");
        dsDL.destroy();
    }
 
    catch(DKException exc)
    {
     try {
         dsDL.destroy();
     }
     catch (Exception e)
     {
      e.printStackTrace();
     }      
     System.out.println("Exception id " + exc.exceptionId());
     System.out.println("Exception Class Name: " + exc.name());
     System.out.println("Exception message " + exc.getMessage());
     System.out.println("Exception error code " + exc.errorCode());
     System.out.println("Exception error state " + exc.errorState());
     exc.printStackTrace();
    }
    catch (Exception exc)
    {
     try {
         dsDL.destroy();
     }
     catch (Exception e)
     {
      e.printStackTrace();
     }      
     System.out.println("Exception message " + exc.getMessage());
     exc.printStackTrace();
    }

    System.out.println("done ...");
  } // end of main    
}
