/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Enterprise Information Portal for Multiplatforms V8.1 (program number 5724-B43)*
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                         *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************/

// sample connect/execute/disconnect to Fed

/*
 * Filename       : TCallbackExecuteFed.java
 * Description    : Connect to Fed Datastore.
 *                  Query.
 *                  <hit enter> to continue
 *                  Disconnect from Fed Datastore.
 */

import com.ibm.mm.sdk.common.*;
import com.ibm.mm.sdk.server.*;
import java.io.*;
import java.lang.*;
import java.util.*;

// TCallbackExecuteFed class
public class TCallbackExecuteFed implements DKConstantFed
{


  // Main method
  public static void main(String argv[])
  {
          
   // Indicate this is a Console Application on Windows NT/95 for error
   // message display in dos console code page. If this was a Windows
   // GUI (Graphic User Interface) Application this would not be necessary
   // because DK_CM_SS_WINDOWS is the default.
   DKEnvironment.setSubSystem(DK_CM_SS_CONSOLE);

    DKDatastoreFed dsFed = null;
    try {
      //*** for input parameters
      String feddb = new String(""),   // library server
             userid = new String(""),     //userid 
  	     pw = new String(""); // pw

      //-------------------------------------------------------------- 
      // Checking for input parameters
      //-------------------------------------------------------------- 
      if (argv.length < 3)
      {
       System.out.println("Invoke Syntax: " );
       System.out.println("  java TCallbackExecuteFed " +
        "<feddb> <userid> <pw>" );
       return;
      }
      else
      {
       feddb = argv[0];
       userid = argv[1];
       pw = argv[2];
      } 
    
    dsFed = new DKDatastoreFed();
    dkResultSetCursor pCur = null;
    DKNVPair parms[] = null;
    System.out.println("connecting to datastore"); 
    dsFed.connect(feddb,userid,pw,"");
    System.out.println("datastore connected feddb " + feddb + " userid " +
                        userid ); 
     String qryString =  "PARAMETRIC_SEARCH = (ENTITY = FedDL, MAX_RESULTS = 5,";
     qryString += "COND = (FedDLName <> NULL)"; 
     qryString += "); OPTION = (CONTENT = YES)";
    
    System.out.println("Query string = " + qryString);
    TCallbackFed cbkFed = new TCallbackFed();
    InputStreamReader isreader = new InputStreamReader(System.in);
    System.out.println("executing query");
    dsFed.executeWithCallback(qryString,DK_CM_FEDERATED_QL_TYPE,parms,(dkCallback)cbkFed);
    System.out.println("datastore executed query");
    boolean isDone = false;
    DKException ckExc = null;
    while (isDone == false)
    {
     isreader.read();
     isDone = cbkFed.isDone();
    }

    ckExc = cbkFed.getException();
    if (ckExc != null)
    {
     System.out.println("Exception name " + ckExc.name());
     System.out.println("Exception message " + ckExc.getMessage());
     System.out.println("Exception error code " + ckExc.errorCode());
     System.out.println("Exception error state " + ckExc.errorState());
     ckExc.printStackTrace();
     cbkFed.resetException(); // reset since it is not needed any more
    }
    System.out.println("query results processed");
    dsFed.disconnect();
    System.out.println("datastore disconnected"); 
    dsFed.destroy();
    }
    catch (DKException exc)
    {
     System.out.println("Exception name " + exc.name());
     System.out.println("Exception message " + exc.getMessage());
     System.out.println("Exception error code " + exc.errorCode());
     System.out.println("Exception error state " + exc.errorState());
     exc.printStackTrace();
    }
    catch (Exception exc)
    {
     System.out.println("Exception message " + exc.getMessage());
     exc.printStackTrace();
    }

  }
}

